clear all;
close all;
addpath('../');
addpath('../Data/dissimilarity');
load('balls3d');

K = d.data;
labels = d.nlab;
labels(labels==2) = -1;

sigma = 0.001;
%W = exp(sigma*W);
W = tanh(sigma*K+0.1);

figure;
[V,D] = eig(W);
subplot(2,2,1);
plot(sort(diag(D)));
min(diag(D))
subplot(2,2,3);

[yy iy] = sort(labels);

imshow(W(iy,iy));

KP = V*abs(D)*V';
subplot(2,2,4);
imagesc(KP(iy,iy));
C = 15;

rn = randperm(d.objsize);
t = round(2*d.objsize/3);

SD = simpleData(W(rn(1:t),rn(1:t)),labels(rn(1:t)));
SD.kernelType = 'precomputed';
tic;
SM = simpleModelENPSVM(SD,C,SD.n);
SM.train;
toc

ypred = SM.test(W(rn(1:t),rn(1:t)));
perfApp = length(find(sign(ypred)==labels(rn(1:t))))/(length(ypred));
disp(['Training accuracy : ', num2str(100*perfApp), '%']);

ypred = SM.test(W(rn(1:t),rn(t+1:end)));
perf = length(find(sign(ypred)==labels(rn(t+1:end))))/(length(ypred));
disp(['Testing accuracy : ', num2str(100*perf), '%']);

tic;
SD = simpleData(W,labels);
SD.kernelType = 'precomputed';
tic;
SM = simpleModelENPSVM(SD,C,SD.n);
perf = SM.crossValError(10);
toc
disp(['Perf Cross Validation : ', num2str(100-perf), '%']);

