% tests sur les donnes d'Hattoibe
function lancerTestHattoibe

clear all;
close all;
addpath('../');
load('../Data/chaises_humanoides.mat');
taille = 100;
%prop=0.2;

kkt = 0.01;
xapp= xapp(:,1:end-1);

% preparer les donnes
y = [ones(taille,1);2*ones(taille,1);3*ones(taille,1)];

classe = 1;
rn = randperm(taille);

x = xapp(y==classe,:);

param = {10.^[-7:1:1]};
%[perf,ttime,DM] = calculer(xa,ya,xt,yt,nu,param,kkt);

prop = 0.02:0.01:0.50;
nu = 0.02:0.02:0.3;
for pp=1:length(prop)
    disp(['loop pp=' num2str(pp)]);
    for nn = 1:length(nu)
        disp(['inside loop nn=' num2str(nn)]);
        xa = x(rn(1:round(prop(pp)*taille)),:)';
        ya = ones(round(prop(pp)*taille),1);
        
        xt = [x(rn(end-round((1-prop(pp))*taille)+1:end),:);xapp(y~=classe,:)]';
        yt = [ones(round((1-prop(pp))*taille),1);-ones(2*taille,1)];
        [perf(pp,nn,:),ttime(pp,nn,:),DM(pp,nn,:,:),P{pp,nn},R{pp,nn}] = calculer(xa,ya,xt,yt,nu(nn),param,kkt);
    end
end


for i=1:4
    perfParNu(i,:) = mean(perf(:,:,i));
    perfParProp(i,:) = mean(perf(:,:,i),2)';
    perfMoyenne(i) = mean(mean(perf(:,:,i)));
    [bp(i),bn(i)] = find(perf(:,:,i)==max(max(perf(:,:,i))),1);
end

perfMoyenne
color='rbgc';
figure;
for i=1:4
    subplot(2,2,1);
    plot(nu,perfParNu(i,:),color(i)); hold on;
    subplot(2,2,2);
    plot(prop,perfParProp(i,:),color(i)); hold on;
    subplot(2,2,3);
    plot(P{bp(i),bn(i)}(i,:),R{bp(i),bn(i)}(i,:),[color(i),'.']); hold on;
end
perf

keyboard

end

function [perf,ttime,DM,P,R] = calculer(xa,ya,xt,yt,nu,param,kkt)

SD = simpleMKLData(xa,ya);
SD.kernelType = {{'rbf','all'}};
SD.kernelParam = param;
C=1/(nu*length(ya));


% tester avec MKLOC
SM = simpleMKLModelOCSVM(SD,nu);
SM.kktgap=kkt;
tic;
SM.train;
ttime(1) = toc;

[ypred(1,:),perf(1)] = SM.test(xt,yt);
[P(1,:),R(1,:)] = precisionRecall(ypred(1,:),yt);
DM(1,:) = SM.dm;

% tester avec MKLSVDD

SM2 = simpleMKLModelSVDD(SD,C);
SM2.kktgap=kkt;
tic;
SM2.train;
ttime(2) = toc;

[ypred(2,:),perf(2)] = SM2.test(xt,yt);
[P(2,:),R(2,:)] = precisionRecall(ypred(2,:),yt);

DM(2,:) = SM2.dm;


SD2 = simpleData(xa,ya);
SD2.kernelType = 'rbf';
% extraire le meilleur noyau MKLOC et lance avec OC

SD2.kernelParam = SM.SD.kernelParam{1}(SM.dm==max(SM.dm));
SD2.kernelParam = SD2.kernelParam(1);
SM3 = simpleModelOCSVM(SD2,nu);
tic;
SM3.train;
ttime(3) = toc;

[ypred(3,:),perf(3)] = SM3.test(xt,yt);
[P(3,:),R(3,:)] = precisionRecall(ypred(3,:),yt);


% extraire le meilleur noyau MKLSVDD et lance avec SVDD


SD4 = simpleData(xa,ya);
SD4.clear
SD4.kernelType = 'rbf';
SD4.kernelParam = SM2.SD.kernelParam{1}(SM2.dm==max(SM2.dm));
SD4.kernelParam = SD4.kernelParam(1);
SM4 = simpleModelSVDD(SD4,C);
tic;
SM4.train;
ttime(4) = toc;
[ypred(4,:),perf(4)] = SM4.test(xt,yt);
[P(4,:),R(4,:)] = precisionRecall(ypred(4,:),yt);

end


function [P,R] = precisionRecall(ypred,yt)
    P = zeros(size(ypred));
    R = zeros(size(ypred));
    b = unique(ypred);
    %[ypredsorted,ind] = sort(ypred,'descend');
    %b = linspace(min(ypred),max(ypred),100);
    %ytsorted = yt(ind);
    for i=1:length(b)
        %pos = find(ytsorted(1:i)==1);
        vp = length(find(yt'>0 & ypred-b(i)>0));
        fp = length(find(yt'>0 & ypred-b(i)<0));
        fn = length(find(yt'<0 & ypred-b(i)>0));
        P(i) = vp/(vp+fp);
        R(i) = vp/(vp+fn);
    end
end

    