addpath('../');
% test
clear all;
randn('seed',0)
rand('seed',0)
n = 100;
d = 2;
x = 4*rand(d,n)-2;
y = ones(n,1);
y(x(1,:).^2+x(2,:).^2<1+0.1*randn(1,n)) = -1;

n = 100;
d = 2;
xt = randn(d,n);
yt = ones(n,1);
yt(xt(1,:).^2+xt(2,:).^2<1) = -1;


figure(1);
subplot(1,3,1);
plot(x(1,y==1),x(2,y==1),'ro');
hold on;
plot(x(1,y==-1),x(2,y==-1),'bx');

subplot(1,3,3);

nbEig = 50;

SD = simpleData(x,y);
%SD.kernelType = 'rbf';
%SD.kernelParam = [1];

SD.kernelType = 'rbf';
SD.kernelParam = [0.5];
%SD.kernelType = 'poly';
%SD.kernelParam = [3,0.01,1];
C=1000;
SM = simpleModelENPSVM(SD,C,nbEig);
tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();
subplot(1,3,2);
SM.print2D();

SD2 = simpleData(x,y);
SD2.kernelType = 'rbf';
SD2.kernelParam = [0.5];
SD2.getKernelValues(1:SD.n);
A=SD2.kernelCache(1:SD.n,1:SD.n)+0.0001*eye(SD.n);

%rcond(A)
%A = inv(diag(diag(A)))*A;
%rcond(A)

%tr = trace(A)
[v,l] = eig(A);
l2 = sort(diag(abs(l)),1,'descend');
cs = cumsum(l2);
nb = find(cs<0.95*cs(end),1,'last')
min(diag(l))
max(diag(l))
[v,l] = eigs(A,nb);
min(diag(l))
max(diag(l))

[v indices] = find(SM.alpha.*SD.trainlab>0);
min(eigs(A(indices,indices),nb))
max(eigs(A(indices,indices),nb))


[v indices] = find(SM.alpha.*SD.trainlab<0);
%min(eigs(A(indices,indices),nb))
%max(eigs(A(indices,indices),nb))

E = eye(length(SM.alpha));
E(indices,indices) = -1;
E = diag(diag(E));

[U,p] = chol(E*A*E)


keyboard



figure;
C=10;
SD.clear();
SM = simpleModelENPSVM(SD,C,nbEig,SM.Il,SM.Iu,SM.Iw);

tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();


figure;
SD.clear();
SD.kernelParam = [1,-1];
SM = simpleModelENPSVM(SD,C,nbEig,SM.Il,SM.Iu,SM.Iw);


tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();

tic;
valErr = SM.crossValError(3)
toc

figure;
C=[1000,10];
SD.clear();
SM = simpleModelENPSVM(SD,C,nbEig,SM.Il,SM.Iu,SM.Iw);

tic;
SM.train;
toc
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
SM.print2D();



tic;
valErr = SM.crossValError(10)
toc
