addpath('../');
% test
clear all;
close all;
n = 300;
d = 2;
x = randn(d,n);
y = ones(n,1);
y(x(1,:).^2+x(2,:).^2<1+0.1*randn(1,n)) = -1;

n = 1000;
d = 2;
xt = randn(d,n);
yt = ones(n,1);
yt(xt(1,:).^2+xt(2,:).^2<1) = -1;


figure(1);
plot(x(1,y==1),x(2,y==1),'ro');
hold on;
plot(x(1,y==-1),x(2,y==-1),'bx');
figure;


SD = simpleData(x,y);
SD.kernelType = 'tanh';
SD.kernelParam = [0.5,0.2];

SD.getKernelValues(1:SD.n);
A=SD.kernelCache(1:SD.n,1:SD.n);

[V,L] = eigs(A,[],10);
i = 10;
while trace(L)<0.95*trace(A)
    i = i+5;
    [V,L] = eigs(A,[],i);
end
figure(2);
plot(diag(L));
negs = find(diag(L)<0);
B = V*abs(L)*V';
SD.kernelCache(1:SD.n,1:SD.n) = B;

%SD.kernelType = 'poly';
%SD.kernelParam = [3,0.01,1];
C=100;
SM = simpleModelCSVM(SD,C);
tic;
SM.train;
toc

% test sans revenir
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
figure(1);
SM.print2D();
keyboard;

SM.alpha = V'*(SM.alpha.*SM.SD.trainlab);
SM.alpha(negs) = -SM.alpha(negs);
SM.alpha = (V*SM.alpha).*SM.SD.trainlab;

% test en revenant dans l'espace de dpart
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
figure(3);
SM.print2D();
keyboard;


% en gardant les valeurs propres seulement
SD.kernelCache(1:SD.n,1:SD.n) = abs(L);
SD.trainvec = V'*SD.trainvec;

SM = simpleModelCSVM(SD,C);
tic;
SM.train;
toc

alpha = SM.alpha;

SM.SD.trainlab = V*SM.SD.trainlab;
SM.alpha = V*(SM.alpha.*SM.SD.trainlab);
SM.alpha = (SM.alpha).*SM.SD.trainlab;

% test en revenant dans l'espace de dpart
tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
figure(5);
SM.print2D();
keyboard;

% test avec solution parcimonieuse?
SM.alpha = V'\(SM.alpha.*SM.SD.trainlab);
SM.alpha = (SM.alpha).*SM.SD.trainlab;

tic;
[ypred,perf] = SM.test(xt,yt);
toc
disp(perf)
figure(6);
SM.print2D();
keyboard;


