function GN = normaliserGraphes(G)
% function GN = normaliserGraphes(G)
% fonction de normalisation d'etiquettes des graphes
%
%%%%%%%%%%%%%%%%%%%
% 06/2006 F-Suard %
%%%%%%%%%%%%%%%%%%%

nbgraph = length(G);

meanNoeud = zeros(1,size(G{1}.etiquetteNoeud,2));
meanArc = zeros(1,size(G{1}.etiquetteArc,2));
nbNoeuds = 0;
nbArcs = 0;
%calcul facteur normalisation
for i=1:nbgraph
    meanNoeud = meanNoeud + sum(G{i}.etiquetteNoeud,1);
    meanArc = meanArc + sum(G{i}.etiquetteArc,1);
    nbNoeuds = nbNoeuds + size(G{i}.etiquetteNoeud,1);
    nbArcs = nbArcs + size(G{i}.etiquetteArc,1);
end
meanNoeud = meanNoeud./nbNoeuds;
meanArc = meanArc./nbArcs;

stdNoeud = zeros(1,size(G{1}.etiquetteNoeud,2));
stdArc = zeros(1,size(G{1}.etiquetteArc,2));
for i=1:nbgraph
    stdNoeud = stdNoeud + sum( (G{i}.etiquetteNoeud-repmat(meanNoeud,size(G{i}.etiquetteNoeud,1),1)).^2 );
    stdArc = stdArc + sum( (G{i}.etiquetteArc-repmat(meanArc,size(G{i}.etiquetteArc,1),1)).^2 );
end
stdNoeud = sqrt(stdNoeud./nbNoeuds);
stdArc = sqrt(stdArc./nbArcs);


%normalisation des etiquettes des graphes
GN = G;
for i=1:nbgraph
    GN{i}.etiquetteArc=(G{i}.etiquetteArc-repmat(meanArc,size(G{i}.etiquetteArc,1),1))./(repmat(stdArc,size(G{i}.etiquetteArc,1),1)+eps);
    GN{i}.etiquetteNoeud = (G{i}.etiquetteNoeud-repmat(meanNoeud,size(G{i}.etiquetteNoeud,1),1))./(repmat(stdNoeud,size(G{i}.etiquetteNoeud,1),1)+eps);  
end
